<template>
    <Head>
        <title>Редактирование характеристики товара {{ productTypeTitle }}</title>
    </Head>
    <div class="g-titlebar">
        <h1>Редактирование характеристики товара {{ productTypeTitle }}</h1>
        <Link :href="`/product_types/${productTypeName}/product_props/`" class="right">
            <font-awesome-icon icon="rotate-left" />
            Вернуться к списку характеристик
        </Link>
    </div>
    <form class="b-form" :class="{ loading: form.processing }" @submit.prevent="submit">
        <b-formrow
            title="Название"
            hint="Человекопонятное название, например: Ширина"
            class="type_text"
            :error="errors.title"
        >
            <el-input type="text" v-model="form.title" />
        </b-formrow>
        <b-formrow
            title="Имя шорткода"
            hint="Англоязычное слово, обозначающее шорткод и GET-параметр в фильтрах. Напр.: width."
            class="type_text"
            :error="errors.slug"
        >
            <el-input type="text" v-model="form.slug" />
        </b-formrow>
        <b-formrow title="Тип данных" class="type_select" :error="errors.type">
            <el-select v-model="form.type" placeholder="Выберите">
                <el-option v-for="(oValue, oTitle) in productPropTypes" :key="oValue" :label="oValue" :value="oTitle" />
            </el-select>
        </b-formrow>
        <b-formrow class="type_switch" :error="errors.is_multiple" v-if="form.type === 'enum'">
            <el-switch v-model="form.is_multiple" active-text="Может одновременно иметь несколько значений" />
        </b-formrow>
        <b-formrow
            title="Число знаков в десятичной части"
            class="type_select"
            :error="errors.decimal_numbers"
            v-if="form.type === 'decimal'"
        >
            <el-select v-model="form.decimal_numbers" placeholder="Выберите">
                <el-option
                    v-for="(oValue, oTitle) in decimalNumbersOptions"
                    :key="oValue"
                    :label="oValue"
                    :value="oTitle"
                />
            </el-select>
        </b-formrow>

        <h2>Валидация</h2>
        <b-formrow class="type_alert" v-if="form.type === 'enum'">
            <el-alert title="Только значения из списка считаются корректными." type="info" :closable="false" />
        </b-formrow>
        <b-formrow
            title="Рег.выражение для валидации"
            hint="Регулярное выражение для проверки правильности значения. Например: ~^.{10,255}$~ — строка от 10 до 255 символов длиной."
            class="type_text"
            :error="errors.validation_regexp"
            v-if="form.type === 'string'"
        >
            <el-input type="text" v-model="form.validation_regexp" />
        </b-formrow>
        <b-formrow
            title="Минимальное значение"
            class="type_text"
            :error="errors.min_value"
            v-if="form.type === 'int' || form.type === 'decimal'"
        >
            <el-input type="text" v-model="form.min_value" />
        </b-formrow>
        <b-formrow
            title="Максимальное значение"
            class="type_text"
            :error="errors.max_value"
            v-if="form.type === 'int' || form.type === 'decimal'"
        >
            <el-input type="text" v-model="form.max_value" />
        </b-formrow>

        <h2>Получение из прайс-листов</h2>
        <b-formrow
            hint="Характеристика может быть получена/импортирована из прайс-листа магазинов"
            class="type_switch"
            :error="errors.is_pricelist_prop"
        >
            <el-switch v-model="form.is_pricelist_prop" active-text="Есть в прайс-листах" />
        </b-formrow>
        <b-formrow
            title="Синонимы в прайс-листах"
            class="type_list"
            :error="errors.synonyms"
            v-if="form.is_pricelist_prop"
        >
            <el-select
                v-model="form.synonyms"
                multiple
                filterable
                allow-create
                default-first-option
                :reserve-keyword="false"
                placeholder="Начните вводить и нажмите Enter"
            />
        </b-formrow>
        <b-formrow
            class="type_switch"
            hint="Если значение отсутствует в прайс-листе магазина или не проходит валидацию, то будет создана ошибка распознавания"
            :error="errors.required_for_offer"
            v-if="form.is_pricelist_prop"
        >
            <el-switch
                v-model="form.required_for_offer"
                active-text="Должно быть распознано для публикации предложения"
            />
        </b-formrow>

        <h2>Отображение в карточке товара</h2>
        <b-formrow
            hint="Одинаковое для всех предложений в рамках одной модели, заполняется через админку и в карточке товара выводится как характеристика МОДЕЛИ, а не ПРЕДЛОЖЕНИЯ."
            class="type_switch"
            :error="errors.is_model_prop"
        >
            <el-switch v-model="form.is_model_prop" active-text="Характеристика модели" />
        </b-formrow>
        <b-formrow
            hint="Если не заполнено или не проходит валидацию, то карточку товара нельзя будет опубликовать."
            class="type_switch"
            :error="errors.required_for_model"
            v-if="form.is_model_prop"
        >
            <el-switch
                v-model="form.required_for_model"
                active-text="Должно быть заполнено для публикации карточки товара"
            />
        </b-formrow>

        <h2>Отображение в фильтрах</h2>
        <b-formrow
            hint="Выводить фильтр по этой характеристике на странице каталога. (А если это НЕ характеристика модели, то и на странице карточки товара.)"
            class="type_switch"
            :error="errors.is_filter_prop"
        >
            <el-switch v-model="form.is_filter_prop" active-text="Есть в фильтрах" />
        </b-formrow>
        <div v-if="form.is_filter_prop">
            <b-formrow class="type_switch" :error="errors.is_parent_tag">
                <el-switch v-model="form.is_parent_tag" active-text="Может содержать вложенные теги" />
            </b-formrow>
            <b-formrow title="Заголовок фильтра" class="type_text" :error="errors.filter_title">
                <el-input type="text" v-model="form.filter_title" />
            </b-formrow>
            <b-formrow
                title="URL API списка значений"
                hint="Список значений фильтра будет получаться из внутреннего микросервиса по заданному API URL"
                class="type_text"
                :error="errors.filter_options_url"
                v-if="!form.is_pricelist_prop && !form.is_model_prop"
            >
                <el-input type="text" v-model="form.filter_options_url" />
            </b-formrow>
            <b-formrow title="Отображать варианты как" class="type_text" :error="errors.filter_options_layout">
                <el-radio-group v-model="form.filter_options_layout">
                    <el-radio-button v-for="(oValue, oTitle) in filterOptionsLayouts" :key="oValue" :label="oTitle">
                        {{ oTitle }}
                    </el-radio-button>
                </el-radio-group>
            </b-formrow>
            <b-formrow
                hint="Будет выводиться поле быстрого поиска, по которому посетитель сможет отфильтровать значения"
                class="type_switch"
                :error="errors.filter_has_search"
            >
                <el-switch v-model="form.filter_has_search" active-text="Показывать поле ввода для быстрого поиска" />
            </b-formrow>
            <b-formrow title="Упорядочить варианты" class="type_text" :error="errors.filter_options_order">
                <el-radio-group v-model="form.filter_options_order">
                    <el-radio-button v-for="(oValue, oTitle) in filterOptionsOrders" :key="oValue" :label="oTitle">
                        {{ oTitle }}
                    </el-radio-button>
                </el-radio-group>
            </b-formrow>
            <b-formrow title="Подсказка к фильтру" class="type_text" :error="errors.filter_hint">
                <el-input type="text" v-model="form.filter_hint" />
            </b-formrow>
        </div>
        <b-formrow>
            <button class="g-button">Создать характеристику товара</button>
        </b-formrow>
    </form>
</template>

<script>
import { router } from "@inertiajs/vue3";

export default {
    props: {
        id: Number,
        // Это первоначальные значения. Текущие — в this.form
        values: Object,
        productTypeName: String,
        productTypeTitle: String,
        productPropTypes: Object,
        decimalNumbersOptions: Object,
        filterOptionsLayouts: Object,
        filterOptionsOrders: Object,
        errors: Object,
    },
    data() {
        return {
            form: { ...this.values },
        };
    },
    methods: {
        submit() {
            router.put(`/product_props/${this.id}`, this.form);
        },
    },
};
</script>

<style scoped></style>
